package net.roseindia;

import net.roseindia.model.*;

import java.util.*;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.ParameterMode;
import javax.persistence.Persistence;
import javax.persistence.StoredProcedureQuery;
import javax.persistence.Query;
		/*
		//Compile mvn compile
		//Run: mvn exec:java -Dexec.mainClass="net.roseindia.AppTestCRUD"
		
		*/
/**
* @author Deepak Kumar
* More tutorials at http://www.roseindia.net
*/
		
public class AppTestCRUD {

	private static final String PERSISTENCE_UNIT_NAME = "psunit1";
	private static EntityManagerFactory factory;

	public static void main(String[] args) {
		factory = Persistence.createEntityManagerFactory(PERSISTENCE_UNIT_NAME);
		EntityManager em = factory.createEntityManager();

		em.getTransaction().begin();
		
		//Create and Persist 10 Objects
		for(int i=1;i<=10;i++){
			Product product = new Product();
			product.setProductName("Java Book No. "+i);
			product.setProductDescription("This is the Book No. "+i);
			product.setStockQty(100.00+i);
			product.setPrice(95.99+i);
			em.persist(product);
		}
		em.getTransaction().commit();
		
		
		
		
		em.getTransaction().begin();
		//Read Operation
		
		
		//Select all the record from student table
		Query query = em.createQuery("SELECT o FROM Product o");
		List lst = query.getResultList();
		Iterator it = lst.iterator();
		while (it.hasNext()){
			Product product = (Product) it.next();
			System.out.print("Id: "+product.getId());
			System.out.print("Product Name: "+product.getProductName());
			System.out.println("Product Description: "+product.getProductDescription());
			System.out.println("Product Qty: "+product.getStockQty());
			System.out.println("Product Price: "+product.getPrice());
		}
		
		em.getTransaction().commit();
		
		/* Update Example */
		//Load and update Entity Eample
		em.getTransaction().begin();
		//find 
		Product product = em.find(Product.class,1);
		product.setProductDescription("Product description Updated");
		//update
		em.merge(product);
		em.getTransaction().commit();
		
		/* Delete Example */
		em.getTransaction().begin();
		//find 
		Product prodObj = em.find(Product.class,2);
		//delete
		em.remove(prodObj);
		em.getTransaction().commit();
		
		
		em.close();
		
	}
}
